/*
 * This source file was generated by FireStorm/DAO.
 * 
 * If you purchase a full license for FireStorm/DAO you can customize this header file.
 * 
 * For more information please visit http://www.codefutures.com/products/firestorm
 */

package umgnotas.eis.jdbc;

import umgnotas.eis.dao.*;
import umgnotas.eis.factory.*;
import umgnotas.eis.dto.*;
import umgnotas.eis.exceptions.*;
import java.sql.Connection;
import java.util.Collection;
import java.sql.PreparedStatement;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Time;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;

public class TbAsignacionDaoImpl extends AbstractDAO implements TbAsignacionDao
{
	/** 
	 * The factory class for this DAO has two versions of the create() method - one that
takes no arguments and one that takes a Connection argument. If the Connection version
is chosen then the connection will be stored in this attribute and will be used by all
calls to this DAO, otherwise a new Connection will be allocated for each operation.
	 */
	protected java.sql.Connection userConn;

	/** 
	 * All finder methods in this class use this SELECT constant to build their queries
	 */
	protected final String SQL_SELECT = "SELECT asi_codigo, asi_nota, asi_cur_codigo, asi_est_carne FROM " + getTableName() + "";

	/** 
	 * Finder methods will pass this value to the JDBC setMaxRows method
	 */
	protected int maxRows;

	/** 
	 * SQL INSERT statement for this table
	 */
	protected final String SQL_INSERT = "INSERT INTO " + getTableName() + " ( asi_codigo, asi_nota, asi_cur_codigo, asi_est_carne ) VALUES ( ?, ?, ?, ? )";

	/** 
	 * SQL UPDATE statement for this table
	 */
	protected final String SQL_UPDATE = "UPDATE " + getTableName() + " SET asi_codigo = ?, asi_nota = ?, asi_cur_codigo = ?, asi_est_carne = ? WHERE asi_codigo = ?";

	/** 
	 * SQL DELETE statement for this table
	 */
	protected final String SQL_DELETE = "DELETE FROM " + getTableName() + " WHERE asi_codigo = ?";

	/** 
	 * Index of column asi_codigo
	 */
	protected static final int COLUMN_ASI_CODIGO = 1;

	/** 
	 * Index of column asi_nota
	 */
	protected static final int COLUMN_ASI_NOTA = 2;

	/** 
	 * Index of column asi_cur_codigo
	 */
	protected static final int COLUMN_ASI_CUR_CODIGO = 3;

	/** 
	 * Index of column asi_est_carne
	 */
	protected static final int COLUMN_ASI_EST_CARNE = 4;

	/** 
	 * Number of columns
	 */
	protected static final int NUMBER_OF_COLUMNS = 4;

	/** 
	 * Index of primary-key column asi_codigo
	 */
	protected static final int PK_COLUMN_ASI_CODIGO = 1;

	/** 
	 * Inserts a new row in the tb_asignacion table.
	 */
	public TbAsignacionPk insert(TbAsignacion dto) throws TbAsignacionDaoException
	{
		long t1 = System.currentTimeMillis();
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			stmt = conn.prepareStatement( SQL_INSERT );
			int index = 1;
			if (dto.getAsiCodigo() != null) {
				stmt.setInt( index++, dto.getAsiCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (dto.getAsiNota() != null) {
				stmt.setInt( index++, dto.getAsiNota().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (dto.getAsiCurCodigo() != null) {
				stmt.setInt( index++, dto.getAsiCurCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			stmt.setString( index++, dto.getAsiEstCarne() );
			System.out.println( "Executing " + SQL_INSERT + " with DTO: " + dto );
			int rows = stmt.executeUpdate();
			long t2 = System.currentTimeMillis();
			System.out.println( rows + " rows affected (" + (t2-t1) + " ms)" );
			reset(dto);
			return dto.createPk();
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbAsignacionDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Updates a single row in the tb_asignacion table.
	 */
	public void update(TbAsignacionPk pk, TbAsignacion dto) throws TbAsignacionDaoException
	{
		long t1 = System.currentTimeMillis();
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			System.out.println( "Executing " + SQL_UPDATE + " with DTO: " + dto );
			stmt = conn.prepareStatement( SQL_UPDATE );
			int index=1;
			if (dto.getAsiCodigo() != null) {
				stmt.setInt( index++, dto.getAsiCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (dto.getAsiNota() != null) {
				stmt.setInt( index++, dto.getAsiNota().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (dto.getAsiCurCodigo() != null) {
				stmt.setInt( index++, dto.getAsiCurCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			stmt.setString( index++, dto.getAsiEstCarne() );
			if (pk.getAsiCodigo() != null) {
				stmt.setInt( 5, pk.getAsiCodigo().intValue() );
			} else {
				stmt.setNull(5, java.sql.Types.INTEGER);
			}
		
			int rows = stmt.executeUpdate();
			reset(dto);
			long t2 = System.currentTimeMillis();
			System.out.println( rows + " rows affected (" + (t2-t1) + " ms)" );
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbAsignacionDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Deletes a single row in the tb_asignacion table.
	 */
	public void delete(TbAsignacionPk pk) throws TbAsignacionDaoException
	{
		long t1 = System.currentTimeMillis();
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			System.out.println( "Executing " + SQL_DELETE + " with PK: " + pk );
			stmt = conn.prepareStatement( SQL_DELETE );
			if (pk.getAsiCodigo() != null) {
				stmt.setInt( 1, pk.getAsiCodigo().intValue() );
			} else {
				stmt.setNull(1, java.sql.Types.INTEGER);
			}
		
			int rows = stmt.executeUpdate();
			long t2 = System.currentTimeMillis();
			System.out.println( rows + " rows affected (" + (t2-t1) + " ms)" );
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbAsignacionDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Returns the rows from the tb_asignacion table that matches the specified primary-key value.
	 */
	public TbAsignacion findByPrimaryKey(TbAsignacionPk pk) throws TbAsignacionDaoException
	{
		return findByPrimaryKey( pk.getAsiCodigo() );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_codigo = :asiCodigo'.
	 */
	public TbAsignacion findByPrimaryKey(Integer asiCodigo) throws TbAsignacionDaoException
	{
		TbAsignacion ret[] = findByDynamicSelect( SQL_SELECT + " WHERE asi_codigo = ?", new Object[] { asiCodigo } );
		return ret.length==0 ? null : ret[0];
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria ''.
	 */
	public TbAsignacion[] findAll() throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT, null );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_cur_codigo = :asiCurCodigo'.
	 */
	public TbAsignacion[] findByTbCurso(int asiCurCodigo) throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE asi_cur_codigo = ?", new Object[] {  new Integer(asiCurCodigo) } );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_est_carne = :asiEstCarne'.
	 */
	public TbAsignacion[] findByTbEstudiante(String asiEstCarne) throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE asi_est_carne = ?", new Object[] { asiEstCarne } );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_codigo = :asiCodigo'.
	 */
	public TbAsignacion[] findWhereAsiCodigoEquals(int asiCodigo) throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE asi_codigo = ? ORDER BY asi_codigo", new Object[] {  new Integer(asiCodigo) } );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_nota = :asiNota'.
	 */
	public TbAsignacion[] findWhereAsiNotaEquals(int asiNota) throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE asi_nota = ? ORDER BY asi_nota", new Object[] {  new Integer(asiNota) } );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_cur_codigo = :asiCurCodigo'.
	 */
	public TbAsignacion[] findWhereAsiCurCodigoEquals(int asiCurCodigo) throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE asi_cur_codigo = ? ORDER BY asi_cur_codigo", new Object[] {  new Integer(asiCurCodigo) } );
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the criteria 'asi_est_carne = :asiEstCarne'.
	 */
	public TbAsignacion[] findWhereAsiEstCarneEquals(String asiEstCarne) throws TbAsignacionDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE asi_est_carne = ? ORDER BY asi_est_carne", new Object[] { asiEstCarne } );
	}

	/**
	 * Method 'TbAsignacionDaoImpl'
	 * 
	 */
	public TbAsignacionDaoImpl()
	{
	}

	/**
	 * Method 'TbAsignacionDaoImpl'
	 * 
	 * @param userConn
	 */
	public TbAsignacionDaoImpl(final java.sql.Connection userConn)
	{
		this.userConn = userConn;
	}

	/** 
	 * Sets the value of maxRows
	 */
	public void setMaxRows(int maxRows)
	{
		this.maxRows = maxRows;
	}

	/** 
	 * Gets the value of maxRows
	 */
	public int getMaxRows()
	{
		return maxRows;
	}

	/**
	 * Method 'getTableName'
	 * 
	 * @return String
	 */
	public String getTableName()
	{
		return "tb_asignacion";
	}

	/** 
	 * Fetches a single row from the result set
	 */
	protected TbAsignacion fetchSingleResult(ResultSet rs) throws SQLException
	{
		if (rs.next()) {
			TbAsignacion dto = new TbAsignacion();
			populateDto( dto, rs);
			return dto;
		} else {
			return null;
		}
		
	}

	/** 
	 * Fetches multiple rows from the result set
	 */
	protected TbAsignacion[] fetchMultiResults(ResultSet rs) throws SQLException
	{
		Collection resultList = new ArrayList();
		while (rs.next()) {
			TbAsignacion dto = new TbAsignacion();
			populateDto( dto, rs);
			resultList.add( dto );
		}
		
		TbAsignacion ret[] = new TbAsignacion[ resultList.size() ];
		resultList.toArray( ret );
		return ret;
	}

	/** 
	 * Populates a DTO with data from a ResultSet
	 */
	protected void populateDto(TbAsignacion dto, ResultSet rs) throws SQLException
	{
		dto.setAsiCodigo( new Integer( rs.getInt(COLUMN_ASI_CODIGO) ) );
		dto.setAsiNota( new Integer( rs.getInt(COLUMN_ASI_NOTA) ) );
		dto.setAsiCurCodigo( new Integer( rs.getInt(COLUMN_ASI_CUR_CODIGO) ) );
		dto.setAsiEstCarne( rs.getString( COLUMN_ASI_EST_CARNE ) );
	}

	/** 
	 * Resets the modified attributes in the DTO
	 */
	protected void reset(TbAsignacion dto)
	{
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the specified arbitrary SQL statement
	 */
	public TbAsignacion[] findByDynamicSelect(String sql, Object[] sqlParams) throws TbAsignacionDaoException
	{
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			// construct the SQL statement
			final String SQL = sql;
		
		
			System.out.println( "Executing " + SQL );
			// prepare statement
			stmt = conn.prepareStatement( SQL );
			stmt.setMaxRows( maxRows );
		
			// bind parameters
			for (int i=0; sqlParams!=null && i<sqlParams.length; i++ ) {
				stmt.setObject( i+1, sqlParams[i] );
			}
		
		
			rs = stmt.executeQuery();
		
			// fetch the results
			return fetchMultiResults(rs);
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbAsignacionDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(rs);
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Returns all rows from the tb_asignacion table that match the specified arbitrary SQL statement
	 */
	public TbAsignacion[] findByDynamicWhere(String sql, Object[] sqlParams) throws TbAsignacionDaoException
	{
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			// construct the SQL statement
			final String SQL = SQL_SELECT + " WHERE " + sql;
		
		
			System.out.println( "Executing " + SQL );
			// prepare statement
			stmt = conn.prepareStatement( SQL );
			stmt.setMaxRows( maxRows );
		
			// bind parameters
			for (int i=0; sqlParams!=null && i<sqlParams.length; i++ ) {
				stmt.setObject( i+1, sqlParams[i] );
			}
		
		
			rs = stmt.executeQuery();
		
			// fetch the results
			return fetchMultiResults(rs);
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbAsignacionDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(rs);
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	@Override
	public Connection getUserConn() {
		return this.userConn;
	}

	@Override
	public void setUserConn(Connection userConn) {
		this.userConn = userConn;
	}

}
